﻿<AML>
 <Item type="Method" id="905363C441784CC8ADDCDDA079A7C913" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_AR_Post_to_GL
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Checking Choosing Cash Account's Currency.
                -Checking Accounting Period.
                -Checking Opening Balance During Accounting Period.
                -Call C# Method.

            Hooks:
                Type:		ItemType : acc_AccountsReceivable
                Event:		Life Cycle Map ( acc_account_receivable_LC )
                
            Revisions:
                Rev Date		Modified By			Description
                2018-07-23		Chan				Validation check before promote "Post To GL" in Bulk Receivable.
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_AR_Post_to_GL";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var id = this.getProperty("id");
                var acc_date = this.getProperty("acc_date");
                var acc_customer = this.getProperty("acc_customer");
                var acc_reference_no = this.getProperty("acc_reference_no");
                var acc_cash_account = this.getProperty("acc_cash_account");
                var acc_currency = this.getProperty("acc_currency");
                var acc_rate = this.getProperty("acc_rate");
                var acc_operator = this.getProperty("acc_operator");
                var acc_cash_type = this.getProperty("acc_cash_type");
                var acc_total_payment = this.getProperty("acc_total_payment");
                var acc_cash_balance = this.getProperty("acc_cash_balance");
                var acc_is_bulk_payment = this.getProperty("acc_is_bulk_payment");
                var acc_accountdetail_name = "";
                var acc_accountdetails_qry = myInnovator.newItem("acc_AccountDetails", "get");
                acc_accountdetails_qry.setProperty("id", acc_cash_account);
                var acc_accountdetails_qry_result = acc_accountdetails_qry.apply();
                var acc_accountdetails_qry_count = acc_accountdetails_qry_result.getItemCount();
                if (acc_accountdetails_qry_count > 0)
                {
                    var acc_accountdetails_result = acc_accountdetails_qry_result.getItemByIndex(0);
                    var bank_amount = acc_accountdetails_qry_result.getProperty("acc_amount", "");
                    acc_accountdetail_name = acc_accountdetails_qry_result.getProperty("acc_accountdetail_name", "");
                }
                Item acc_AP_Detail = myInnovator.newItem("acc_AccountsReceivableDetail", "get");
                acc_AP_Detail.setProperty("source_id", id);
                Item result_ap = acc_AP_Detail.apply();
                var ap_count = result_ap.getItemCount();
                if (ap_count > 0)
                {
                    for (int i = 0; i < ap_count; i++)
                    {
                        var acc_AP = result_ap.getItemByIndex(i);
                        string acc_sop_currency = acc_AP.getProperty("acc_sop_currency");
                        if (acc_currency != acc_sop_currency)//2018-07-23
                        {
                            return myInnovator.newError("Need to edit for this receivable.Please check Bank Account.Must be same Bank Account's Currency and Sale's Currency");
                        }
                    }
                }
                if (acc_cash_type != null)//2018-07-23
                {
                    if (acc_is_bulk_payment == "1")
                    {

                        /*Check Opening Balance*/
                        Item _acc_periods_item = myInnovator.newItem("acc_periods", "get");
                        _acc_periods_item.setProperty("openingclsoingperiod", "0");
                        _acc_periods_item.setPropertyCondition("openingclsoingperiod", "eq");
                        var l_chk_result = _acc_periods_item.apply();
                        var l_chk_count = l_chk_result.getItemCount();

                        if (l_chk_count <= 0)
                        {
                            return myInnovator.newError("You must create new accounting Periods for this transaction!");
                        }
                        else
                        {
                            for (var i = 0; i < l_chk_count; i++)
                            {
                                l_chk_result = l_chk_result.getItemByIndex(i);
                                var startperiod = l_chk_result.getProperty("startperiod", "");
                                DateTime dt_startperiod = DateTime.Parse(startperiod);
                                dt_startperiod = new DateTimeOffset(dt_startperiod, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                                var local_startperiod = dt_startperiod.ToString("yyyy-MM-dd");

                                var endperiod = l_chk_result.getProperty("endperiod", "");
                                DateTime dt_endperiod = DateTime.Parse(endperiod);
                                dt_endperiod = new DateTimeOffset(dt_endperiod, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                                var local_endperiod = dt_endperiod.ToString("yyyy-MM-dd");

                                var openingbalancequery = "select top 1 (acc_amount_currency) from innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.SOURCE_ID= acc_journal_header.id where ACC_TRANSACTIONTYPE='Opening Balance' and acc_accountid='" + acc_cash_account + "' and  (Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (acc_journal_header.acc_date as datetime),'yyyy/MM/dd h:mm:s tt')),111) Between Convert(Date,'" + startperiod + "',111) and Convert(Date,'" + endperiod + "',111))";

                                var getOpeningBalanceData = myInnovator.applySQL(openingbalancequery);
                                var opcount = getOpeningBalanceData.getItemCount();
                                if (opcount <= 0)
                                {
                                    return myInnovator.newError("You must create opening balance for this bank account ( " + acc_accountdetail_name + " ) Between " + local_startperiod + " And " + local_endperiod + " of accounting period in journal!");

                                }
                                else
                                {
                                    var return_message = myInnovator.applyMethod("acc_AR_Bulk_call",
                                    "<id>" + id + "</id>" +
                                    "<acc_date>" + acc_date + "</acc_date>" +
                                    "<acc_customer>" + acc_customer + "</acc_customer>" +
                                     "<acc_cash_account>" + acc_cash_account + "</acc_cash_account>" +
                                      "<acc_currency>" + acc_currency + "</acc_currency>" +
                                       "<acc_rate>" + acc_rate + "</acc_rate>" +
                                        "<acc_operator>" + acc_operator + "</acc_operator>" +
                                    "<acc_reference_no>" + acc_reference_no + "</acc_reference_no>");
                                }
                            }

                        }
                        /*End Opening Balance*/
                    }
                    else
                    {
                        /*Check Opening Balance*/
                        Item _acc_periods_item = myInnovator.newItem("acc_periods", "get");
                        _acc_periods_item.setProperty("openingclsoingperiod", "0");
                        _acc_periods_item.setPropertyCondition("openingclsoingperiod", "eq");
                        var l_chk_result = _acc_periods_item.apply();
                        var l_chk_count = l_chk_result.getItemCount();

                        if (l_chk_count <= 0)
                        {
                            return myInnovator.newError("You must create new accounting Periods for this transaction!");
                        }
                        else
                        {
                            for (var i = 0; i < l_chk_count; i++)
                            {
                                l_chk_result = l_chk_result.getItemByIndex(i);
                                var startperiod = l_chk_result.getProperty("startperiod", "");
                                DateTime dt_startperiod = DateTime.Parse(startperiod);
                                dt_startperiod = new DateTimeOffset(dt_startperiod, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                                var local_startperiod = dt_startperiod.ToString("yyyy-MM-dd");

                                var endperiod = l_chk_result.getProperty("endperiod", "");
                                DateTime dt_endperiod = DateTime.Parse(endperiod);
                                dt_endperiod = new DateTimeOffset(dt_endperiod, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                                var local_endperiod = dt_endperiod.ToString("yyyy-MM-dd");

                                var openingbalancequery = "select top 1 (acc_amount_currency) from innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.SOURCE_ID= acc_journal_header.id where ACC_TRANSACTIONTYPE='Opening Balance' and acc_accountid='" + acc_cash_account + "' and  (Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (acc_journal_header.acc_date as datetime),'yyyy/MM/dd h:mm:s tt')),111) Between Convert(Date,'" + startperiod + "',111) and Convert(Date,'" + endperiod + "',111))";

                                var getOpeningBalanceData = myInnovator.applySQL(openingbalancequery);
                                var opcount = getOpeningBalanceData.getItemCount();
                                if (opcount <= 0)
                                {
                                    return myInnovator.newError("You must create opening balance for this bank account ( " + acc_accountdetail_name + " ) Between " + local_startperiod + " And " + local_endperiod + " of accounting period in journal!");

                                }
                                else
                                {
                                    var return_message = myInnovator.applyMethod("acc_AR_Unload_call",
                                    "<id>" + id + "</id>" +
                                    "<acc_date>" + acc_date + "</acc_date>" +
                                    "<acc_customer>" + acc_customer + "</acc_customer>" +
                                    "<acc_reference_no>" + acc_reference_no + "</acc_reference_no>");
                                }
                            }

                        }
                        /*End Opening Balance*/
                    }
                }
                else
                {
                    return myInnovator.newError("Need to edit for this Receivable.Cash Type is required Field!");
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_AR_Post_to_GL</name>
 </Item>
</AML>